(load "objsys.scm") (load "assert.scm")

(define (create-set items)
  (create-instance set items))

(define (set self items)
  (let ((root-part (root-object self)))
    (make-handler
     'set
     (make-methods
      'CONTAINS?
      (lambda (item)
        (let ((contains (memv item items)))
          (if contains #t #f)))
      'INSERT!
      (lambda (item)
        (if (not (ask self 'CONTAINS? item))
            (set! items (cons item items))))
      'REMOVE!
      (lambda (item)
        (set! items (delq! item items)))
      '->LIST
      (lambda ()
        items)
      'UNION
      (lambda (other)
        (let ((new (create-set (ask self '->LIST))))
          (for-each (lambda (i) (ask new 'INSERT! i))
                    (ask other '->LIST))
          new)))
     root-part)))

(define s1 (create-set nil))
(define s2 (create-set '(1 2 3)))
(assert-equal (sort (ask s1 '->LIST) <) '())
(assert-equal (sort (ask s2 '->LIST) <) '(1 2 3))
(assert-f (ask s1 'CONTAINS? 1))
(assert-t (ask s2 'CONTAINS? 1))
(ask s1 'INSERT! 0)
(ask s2 'REMOVE! 3)
(assert-equal (sort (ask (ask s1 'UNION s2) '->LIST) <) '(0 1 2))
(assert-equal (sort (ask (ask s2 'UNION s1) '->LIST) <) '(0 1 2))





